Name: hencsat
Version: 0.6.0~rc1.0
Release: 1
Summary: HENCSAT Test Bench
Group: Applications/Internet
License: GPLv3
URL: https://git.ansur.no/hencsat.git
Source: https://packages.nntb.no/sources/%{name}-%{version}.tar.gz

AutoReqProv: on
BuildRequires: cmake
BuildRequires: dejavu-sans-fonts
BuildRequires: dejavu-sans-mono-fonts
BuildRequires: dejavu-serif-fonts
BuildRequires: gcc
BuildRequires: ghostscript
BuildRequires: gimp
BuildRequires: google-noto-cjk-fonts
BuildRequires: google-noto-sans-fonts
BuildRequires: google-noto-serif-fonts
BuildRequires: GraphicsMagick
BuildRequires: perl-Image-ExifTool
BuildRequires: urw-base35-fonts
BuildRequires: lksctp-tools-devel
BuildRequires: qt5-qtbase-devel
BuildRequires: qt5-linguist
BuildRequires: qtchooser
BuildRoot: %{_tmppath}/%{name}-%{version}-build


# This package does not generate debug information (no executables):
%global debug_package %{nil}

# TEST ONLY:
# %define _unpackaged_files_terminate_build 0


%description
This package contains software for HENCSAT Test Bench system management.
The software installed provides a common working environment.
See https://www.simula.no for details on HENCSAT!

%prep
%setup -q

%build
%cmake -DCMAKE_INSTALL_PREFIX=/usr -DFLAT_DIRECTORY_STRUCTURE=0 .
make %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} install
# ====== Relocate files =====================================================
mkdir -p %{buildroot}/boot/HENCSAT
for name in HSClient1 HSController1 HSDevelopment1 HSManagement1 HSRouter1 HSServer1 ; do
   mv %{buildroot}/usr/share/hencsat-desktop/splash/${name}-1024x768.jpeg %{buildroot}/boot/HENCSAT
done
mkdir -p %{buildroot}/etc/hencsat
mv %{buildroot}/usr/share/hencsat-desktop/splash/hencsat-version %{buildroot}/etc/hencsat
# ===========================================================================


%package management
Summary: HENCSAT Management
Group: Applications/Internet
Requires: bash-completion
Requires: bridge-utils
Requires: btrfs-progs
Requires: bc
Requires: bwm-ng
Requires: colordiff
Requires: cronie
Requires: ethtool
Requires: git
Requires: gpm
Requires: hping3
Requires: htop
Requires: ipsec-tools
Requires: joe
Requires: jq
Requires: libidn
Requires: lksctp-tools
Requires: mlocate
Requires: net-snmp-utils
Requires: net-tools
Requires: nmap
Requires: ntpdate
Requires: pxz
Requires: reiserfs-utils
Requires: reprepro
Requires: smartmontools
Requires: subnetcalc
Requires: tcpdump
Requires: tftp
Requires: traceroute
Requires: tree
Requires: vconfig
Requires: virt-what
Requires: whois
Recommends: grub2-tools
Recommends: netperfmeter
Recommends: rsplib-docs
Recommends: rsplib-services
Recommends: rsplib-tools
Recommends: wireshark-cli

%description management
This metapackage contains basic software for HENCSAT system management.
The software installed provides a common working environment.
See https://www.simula.no for details on HENCSAT!

%files management
/boot/HENCSAT/HSManagement1-1024x768.jpeg
/etc/grub.d/??_hencsat_management_theme
/etc/hencsat/hencsat-version
/usr/bin/HENCSAT-Routing-Rule-Setup
/usr/bin/HENCSAT-System-Info
/usr/bin/HENCSAT-System-Maintenance
/usr/share/man/man1/HENCSAT-Routing-Rule-Setup.1.gz
/usr/share/man/man1/HENCSAT-System-Info.1.gz
/usr/share/man/man1/HENCSAT-System-Maintenance.1.gz 
/usr/share/hencsat/grub-defaults
/usr/share/hencsat/pbuilderrc
%ghost /etc/cron-apt/action.d/5-install

%post management
echo "Updating /etc/default/grub with HENCSAT settings:"
echo "-----"
cat /usr/share/hencsat/grub-defaults | \
   ( if grep "biosdevname=0" >/dev/null 2>&1 /proc/cmdline ; then sed "s/^GRUB_CMDLINE_LINUX=\"/GRUB_CMDLINE_LINUX=\"biosdevname=0 /g" ; else cat ; fi ) | \
   ( if grep "net.ifnames=0" >/dev/null 2>&1 /proc/cmdline ; then sed "s/^GRUB_CMDLINE_LINUX=\"/GRUB_CMDLINE_LINUX=\"net.ifnames=0 /g" ; else cat ; fi ) | tee /etc/default/grub.new && \
mv /etc/default/grub.new /etc/default/grub
echo "-----"
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi

%postun management
rm -f /etc/grub.d/??_hencsat_management_theme
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi


%package firewall
Summary: HENCSAT Firewall
Group: Applications/Internet
Requires: iptables

%description firewall
This package contains the scripts to configure a HENCSAT Management LAN firewall.
See https://www.simula.no for details on HENCSAT!

%files firewall
/usr/bin/Management-LAN-Firewall
/usr/share/man/man1/Management-LAN-Firewall.1.gz
/usr/share/doc/hencsat-firewall/examples/management-lan.conf.example


%package development
Summary: HENCSAT Development
Group: Applications/Internet
Requires: %{name}-management = %{version}-%{release}
Requires: autoconf
Requires: automake
Requires: banner
Requires: bison
Requires: bzip2-devel
Requires: clang
Requires: cmake
Requires: createrepo
Requires: debhelper
Requires: dejavu-sans-fonts
Requires: dejavu-sans-mono-fonts
Requires: dejavu-serif-fonts
Requires: devscripts
Requires: flex
Requires: gcc
Requires: gcc-c++
Requires: gdb
Requires: ghostscript
Requires: gimp
Requires: glib2-devel
Requires: gnupg
Requires: gnuplot
Requires: google-noto-cjk-fonts
Requires: google-noto-sans-fonts
Requires: google-noto-serif-fonts
Requires: GraphicsMagick
Requires: libcurl-devel
Requires: libpcap-devel
Requires: libtool
Requires: lksctp-tools-devel
Requires: make
Requires: mock
Requires: openssl-devel
Requires: pbuilder
Requires: perl-Image-ExifTool
Requires: pkg-config
Requires: python3
Requires: qt5-qtbase-devel
Requires: quilt
Requires: R-base
Requires: rpm
Requires: texlive-epstopdf-bin
Requires: urw-base35-fonts
Requires: valgrind
Recommends: rsplib-devel

%description development
This meta-package contains basic software for HENCSAT development.
The software installed provides a common working environment.
See https://www.simula.no for details on HENCSAT!

%files development
/boot/HENCSAT/HSDevelopment1-1024x768.jpeg
/etc/grub.d/??_hencsat_development_theme

%post development
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi

%postun development
rm -f /etc/grub.d/??_hencsat_development_theme
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi


%package server
Summary: HENCSAT Server
Group: Applications/Internet
Requires: ffmpeg
Requires: %{name}-management = %{version}-%{release}
Requires: %{name}-firewall = %{version}-%{release}

%description server
This package contains the scripts to configure a HENCSAT server.
See https://www.simula.no for details on HENCSAT!

%files server
/boot/HENCSAT/HSServer1-1024x768.jpeg
/etc/grub.d/??_hencsat_server_theme

%post server
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi

%postun server
rm -f /etc/grub.d/??_hencsat_server_theme
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi


%package desktop
Summary: HENCSAT Desktop
Group: Applications/Internet
Requires: %{name}-management = %{version}-%{release}
Recommends: xorg-x11-drv-vmware

%description desktop
This meta-package contains the scripts to configure a HENCSAT desktop.
See https://www.simula.no for details on HENCSAT!

%files desktop
/usr/share/hencsat-desktop/HENCSAT-A4.pdf
/usr/share/hencsat-desktop/*
%ghost /usr/share/hencsat/splash


%package client
Summary: HENCSAT Client
Group: Applications/Internet
Requires: ffmpeg
Requires: %{name}-desktop = %{version}-%{release}
Requires: %{name}-firewall = %{version}-%{release}
Requires: %{name}-management = %{version}-%{release}

%description client
This package contains the scripts to configure a HENCSAT client.
See https://www.simula.no for details on HENCSAT!

%files client
/boot/HENCSAT/HSClient1-1024x768.jpeg
/etc/grub.d/??_hencsat_client_theme

%post client
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi

%postun client
rm -f /etc/grub.d/??_hencsat_client_theme
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi


%package controller
Summary: HENCSAT Controller
Group: Applications/Internet
Requires: ffmpeg
Requires: %{name}-desktop = %{version}-%{release}
Requires: %{name}-management = %{version}-%{release}

%description controller
This package contains the scripts to configure a HENCSAT controller.
See https://www.simula.no for details on HENCSAT!

%files controller
/boot/HENCSAT/HSController1-1024x768.jpeg
/etc/grub.d/??_hencsat_controller_theme
/usr/bin/HENCSAT-QoS-Controller
/usr/share/hencsat-controller/*.qm

%post controller
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi

%postun controller
rm -f /etc/grub.d/??_hencsat_controller_theme
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi


%package router
Summary: HENCSAT Router
Group: Applications/Internet
Requires: ffmpeg
Requires: %{name}-firewall = %{version}-%{release}
Requires: %{name}-management = %{version}-%{release}

%description router
This package contains the scripts to configure a HENCSAT router.
See https://www.simula.no for details on HENCSAT!

%files router
/boot/HENCSAT/HSRouter1-1024x768.jpeg
/etc/grub.d/??_hencsat_router_theme
/usr/bin/HENCSAT-QoS-Setup
/usr/share/doc/hencsat-router/examples/hencsat-router.conf.example
/usr/share/doc/hencsat-router/examples/sudoers.append
/usr/share/man/man1/HENCSAT-QoS-Setup.1.gz

%post router
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi

%postun router
rm -f /etc/grub.d/??_hencsat_router_theme
if [ -e /usr/sbin/grub2-mkconfig ] ; then /usr/sbin/grub2-mkconfig -o /boot/grub2/grub.cfg || true ; fi


%changelog
* Wed Nov 22 2017 Thomas Dreibholz <dreibh@iem.uni-due.de> - 0.0.0
- Created RPM package.
